﻿//=======================================================================================
//
//  Purpose: Main program loop for controlling 16 LEDs using the TLC5940 PWM chip.
//
//  Copyright (C) 2011 Mark Stevens
//
//  This software is destributed under the MS-PL licence agreement a copy of which can
//  be found on the codeplex page http://netduinoledcontrol.codeplex.com and in the
//  Licence.txt file distributed with this project.
//
//=======================================================================================
using System.Threading;

namespace TLC5940
{
    public class Program
    {
        /// <summary>
        /// Fade the LEDs in and out gently.
        /// </summary>
        /// <param name="leds">Instance of the Tlc5940 used to control the LEDs.</param>
        public static void Breathe(Tlc5940 leds)
        {
            ushort[] ledBrightness;

            ledBrightness = new ushort[16];
            for (int counter = 0; counter < 0xfff; counter += 10)
            {
                if (counter > 0xfff)
                {
                    counter = 0xfff;
                }
                for (int index = 0; index < 16; index++)
                {
                    ledBrightness[index] = (ushort) counter;
                }
                leds.Display(null, ledBrightness);
                Thread.Sleep(10);
            }
            Thread.Sleep(500);
            for (int counter = 0xfff; counter >= 0; counter -= 10)
            {
                if (counter < 0)
                {
                    counter = 0;
                }
                for (int index = 0; index < 16; index++)
                {
                    ledBrightness[index] = (ushort) counter;
                }
                leds.Display(null, ledBrightness);
                Thread.Sleep(10);
            }
            Thread.Sleep(500);
        }

        /// <summary>
        /// Main control loop.
        /// </summary>
        public static void Main()
        {
            Tlc5940 leds;
            leds = new Tlc5940();
            while (true)
            {
                Breathe(leds);
            }
        }
    }
}
